#!/usr/bin/env python

tmp = "/tmp/t2/"

import urllib2, zipfile, shutil, sys, os, re

if len(sys.argv) < 2 or  "--help" in sys.argv or  not os.path.isdir(sys.argv[1]) :
  print "usage: ./t2hack.py /path/to/Dynamix/Tribes2"
  sys.exit()
  
gamedata = sys.argv[1] + "/GameData"

updates = [
  True, #ip
  True #certs
 ]

#get IP
c = urllib2.urlopen("http://tribesnext.com/whatismyip.php")
ip = c.read().lstrip().rstrip()
c.close()

if not re.match("^([0-9]{1,3}\.){3}[0-9]{1,3}$", ip):
  print "Retrieved ip in unrecognised format, please enter manually:"
  ip = raw_input()
  if not re.match("^([0-9]{1,3}\.){3}[0-9]{1,3}$", ip):
    print "still unrecognised, won't be written"
    updates[0] = False

#get certificates
certs = [""]
try:
  f = open(gamedata + "/public.store")
  certs = [line.replace("\n", "").replace("\r", "") for line in f]
  f.close()
except: 
  print "public.store not found - cert won't be updated -- you will need to rerun this script after you have an account."
  updates[1] = False
try:
  z = zipfile.ZipFile(gamedata + "/base/T2csri.vl2.bak")
except:
  print "error:" + gamedata + "/base/T2csri.vl2.bak is an invalid path for T2csri.vl2... exiting."
  sys.exit()
  
# we want to extract neither DSOs nor directory indicators.
toextract = [ member for member in z.namelist() if member[-4:] != ".dso" and member[-1:] != "/" ]

#make extraction path's file tree
for path in toextract:
  try:
    os.makedirs(tmp + "/" + path[:path.rfind("/")])
  except:
    pass

#extract
z.extractall(tmp, toextract)

listcs = "scripts/autoexec/t2csri_list.cs"
ipcs = "t2csri/ipv4.cs"
clientsidecs = "t2csri/clientSide.cs"

#rename t2csri_list
shutil.move(tmp + listcs, tmp + listcs + ".null")

#create additions to ip and clientSide file
ipaddition = "\n\t$IPv4::InetAddress = \"" + ip + "\";\r\n"
certaddition = "\n".join(["\n\tif (%name $= \"" + c.split("\t")[0] + "\")\n\t{\n\t\treturn \"" + c + "\";\t\n\t}" for c in certs])

amendments = [ipaddition, certaddition]
#these are the search strings (regexs) to insert the above additions into the files, right after these are matched.
needles = ["function\sipv4\_getInetAddress\(\)[\s]*\{", "function\st2csri\_getAccountCertificate\(\%name\)[\s]*\{"]
filenames = [tmp + f for f in [ipcs, clientsidecs]]

for i in range( len(amendments) ):
  if not updates[i]: continue
  
  needle = needles[i]
  amendment = amendments[i]
  filename = filenames[i]
  f = open(filename, "r")
  text = f.read()
  #find insertion point
  m = re.search(needle, text)
  if not m:
    print "error: ", needle, "not found in", filename
    continue
    
  location = m.end(0)
  #insert the addition into the new file text
  newtext = text[:location] + amendment + text[location:]
  f.close()
  f = open(filename, "w")
  f.write(newtext)
  f.close()
  
  
#rebuild the vl2  
toextract.remove(listcs)
toextract.append(listcs + ".null")
newvl2 = zipfile.ZipFile(gamedata + "/base/T2csri.vl2", "w")
for f in toextract:
  newvl2.write(tmp + "/" + f, f)
 
#remove any relevant DSOs 
dsos = ["/base/t2csri/ipv4.dso", "/base/t2csri/clientSide.dso", "/scripts/autoexec/t2csri_list.dso"]
for d in dsos:
  try: os.remove(gamedata + d)
  except: continue
  








